#!/usr/bin/env ruby

require 'fox14'
require 'fox14/colors'
require 'Grammatiken'
include Fox



class RuleWindow < FXDialogBox
	def initialize(owner,nonTermArray,termArray,startSymb)
		super(owner,"Regeln erstellen...",DECOR_ALL,0,0,500,350)
		
	  @ruleText		  = String.new()
	  @ruleSign 		= String.new()
	  @ruleComplete = String.new()
	  @grammar			
		@checkNonTerm = Array.new
		puts @checkNonTerm
		
      # Construct a horizontal frame to hold the main window's contents
      @contents = FXHorizontalFrame.new(self,
      LAYOUT_SIDE_TOP|LAYOUT_FILL_X|LAYOUT_FILL_Y, 0, 0, 0, 0, 0, 0, 0, 0)
      
      # Construct a horizontal frame to hold the nontermials
      leftFrame = FXVerticalFrame.new(@contents,
      FRAME_SUNKEN|LAYOUT_FILL_Y|LAYOUT_TOP|LAYOUT_LEFT,
      0, 0, 0, 0, 10, 10, 10, 10)

      # Construct a horizontal frame to show the arrows
      middleFrame = FXVerticalFrame.new(@contents,
      FRAME_SUNKEN|LAYOUT_FILL_X|LAYOUT_FILL_Y|LAYOUT_TOP|LAYOUT_LEFT,
      0, 0, 0, 0, 10, 10, 10, 10)
      
      # Construct a horizontal frame for choosing the terminals
			rightFrame = FXVerticalFrame.new(@contents,
      FRAME_SUNKEN|LAYOUT_FILL_X|LAYOUT_FILL_Y|LAYOUT_TOP|LAYOUT_LEFT,
      0, 0, 0, 0, 10, 10, 10, 10)

			leftLabel = FXLabel.new(leftFrame, "Linke Regelseite:", nil,
      JUSTIFY_CENTER_X|JUSTIFY_CENTER_Y)
			
     	middleLabel = FXLabel.new(middleFrame, "->", nil,
      JUSTIFY_CENTER_X|JUSTIFY_CENTER_Y,0,0,0,0,0,0,23,0)
			
			rightLabel = FXLabel.new(rightFrame, "Rechte Regelseite:", nil,
      JUSTIFY_CENTER_X|JUSTIFY_CENTER_Y)
			
# Linke Seite				
		
		nonTermTextField = FXTextField.new(leftFrame, 13, nil, TEXTFIELD_READONLY|LAYOUT_SIDE_TOP|LAYOUT_FILL_X)
		
		nonTermComboBox = FXComboBox.new(leftFrame, nonTermArray.length,nil, 0,COMBOBOX_STATIC|
		                          FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP|LAYOUT_FILL_X)
		
		for i in 0..nonTermArray.length-1
		  nonTermComboBox.appendItem(nonTermArray[i].to_s)
			@checkNonTerm = @checkNonTerm << nonTermArray[i].to_s
		end
		
		nonTermComboBox.connect(SEL_COMMAND)do
		    for i in 0..nonTermArray.length-1 do
		      if nonTermComboBox.itemCurrent?(i)
		        @ruleSign = nonTermComboBox.getItemText(i)
		        nonTermTextField.text = @ruleSign
						puts "test"
		      end
		    end
		end
	    
	    
# Rechte Seite	
        
		termTextField = FXTextField.new(rightFrame,50,nil, TEXTFIELD_READONLY|LAYOUT_TOP|LAYOUT_FILL_X)
		
		termComboBox = FXComboBox.new(rightFrame, termArray.length,nil, 0,COMBOBOX_STATIC|
		                          FRAME_SUNKEN|FRAME_THICK|LAYOUT_TOP)
		termComboBox.appendItem("epsilon")
		termComboBox.appendItem("|")		
		for i in 0..termArray.length-1
		 termComboBox.appendItem(termArray[i].to_s)                          
		end
		
		for i in 0..nonTermArray.length-1
		  termComboBox.appendItem(nonTermArray[i].to_s)                          
		end
		
		
		termComboBox.connect(SEL_COMMAND)do
		    for i in 0..(termArray.length+nonTermArray.length+1) do
		      if termComboBox.itemCurrent?(i)
		        @ruleText = @ruleText + termComboBox.getItemText(i)+" "
		        termTextField.text = @ruleText
		      end
		    end
		end


#Button zum Besttigen der Grammatik
	grammarButton = FXButton.new(rightFrame, "Grammatik erzeugen",nil,nil,0,
															 FRAME_THICK|FRAME_RAISED|LAYOUT_FILL_X|LAYOUT_CENTER_X|LAYOUT_BOTTOM)
															 
	grammarButton.connect(SEL_COMMAND) do
		if @checkNonTerm.length == 0
			@grammar = Grammar.new(@ruleComplete)
			owner.leadGrammar(@ruleComplete,@grammar)
		else
			errorDialog = FXDialogBox.new(self,"Fehler", DECOR_ALL, 0, 0,250,40)
			FXLabel.new(errorDialog, "Fehler: Alle NON-Terminale mit Regeln besetzen!",
									nil,LAYOUT_LEFT|LAYOUT_TOP|LAYOUT_LEFT)
			errorDialog.execute
		end
	end


#Button zur Besttigung einer Regel	
	commitButton = FXButton.new(rightFrame, "Regel besttigen",nil,nil,0,
	FRAME_THICK|FRAME_RAISED|LAYOUT_FILL_X|LAYOUT_CENTER_X|LAYOUT_BOTTOM)
	
	commitButton.connect(SEL_COMMAND)do
     @ruleText = insert_SIC(@ruleText)
    if (@ruleComplete != "")
	   @ruleComplete = @ruleComplete + " \n\n" + @ruleSign + " -> " + @ruleText
	  
	  else
	   @ruleComplete = @ruleSign + " -> " + @ruleText
	  end
		
	if @checkNonTerm.include?(@ruleSign)
		 @checkNonTerm.delete(@ruleSign)
		 puts @checkNonTerm
	end
		
		@ruleText = ""
	  @ruleSign = ""
	  nonTermTextField.text = @ruleSign
	  termTextField.text = @ruleText
	end





#Button zum Lschen einzelner Symbole aus der aktuellen Regel	
	deleteButton = FXButton.new(rightFrame, "letztes Zeichen lschen",nil,nil,0,
															FRAME_THICK|FRAME_RAISED|LAYOUT_FILL_X|LAYOUT_CENTER_X|LAYOUT_BOTTOM)
	
	deleteButton.connect(SEL_COMMAND)do
	   ruleTemp = @ruleText.split(' ')
	   ruleTemp.delete_at(ruleTemp.length-1)
	   @ruleText = String.new()
	   for i in 0.. ruleTemp.length-1 do
	     @ruleText = @ruleText + ruleTemp[i] + " "
	   end
	   termTextField.text = @ruleText
	end
 end
  
  
  
 def insert_SIC(string)
     stringArray = string.split(' |')
	   newString = String.new()
		 
	
	 if stringArray.length >= 2 
	    for i in 0..stringArray.length-2
			 newString = newString + stringArray[i] + "\n  |"
			end
			newString = newString + stringArray[-1]
	 elsif stringArray.length == 1
			newString = stringArray.to_s
		end
			
		return newString
 end
end

############################################################################################
############################################################################################

# Klasse DialogWindow dient zum ffnen eines Dialogfensters zur Eingabe
# der Nontermiale, Terminale und des Startsymbols
# Autor: Danilo Ebert

class DialogWindow	< FXDialogBox
	
# Erzeugt ein Dialogfenster mit Defaultwerten
	def initialize(owner)
		super(owner,"Grammatik erstellen...", DECOR_ALL, 0, 0,300,400)
		
		menubar  = FXMenuBar.new(self, LAYOUT_SIDE_TOP|LAYOUT_FILL_X)
		filemenu = FXMenuPane.new(self)
	
		FXMenuTitle.new(menubar, "&File", nil, filemenu)
		FXHorizontalSeparator.new(self, SEPARATOR_GROOVE|LAYOUT_FILL_X,20,20,20,20,0,0,0,30)		

# Erzeugt DataTargets fr die Eingabe der Nontermiale, Terminale und des Startsymbols
    	@nonTermTarget  = FXDataTarget.new("A, B, C")
			@termTarget     = FXDataTarget.new("a, b, c")
			@nonTermArray   = Array.new()
			@termArray      = Array.new()
      @startSymb      = String.new()
        

# Label und Textfeld fr die Eingabe der NON-Terminale
	FXLabel.new(self, "Liste der NON-Terminale mit Kommata getrennt:", nil,LAYOUT_LEFT|LAYOUT_TOP|LAYOUT_LEFT)
	FXTextField.new(self, 50, @nonTermTarget,FXDataTarget::ID_VALUE,
									LAYOUT_LEFT|LAYOUT_CENTER_X|FRAME_SUNKEN|FRAME_THICK|
									LAYOUT_LEFT|LAYOUT_FILL_X)

FXHorizontalSeparator.new(self, SEPARATOR_GROOVE|LAYOUT_FILL_X,20,20,20,20,0,0,30,30)		

# Label und Textfeld fr die Eingabe der Terminale
	FXLabel.new(self, "Lister der Terminale mit Kommata getrennt:", nil,LAYOUT_LEFT|LAYOUT_TOP|LAYOUT_LEFT)
	FXTextField.new(self, 10, @termTarget,FXDataTarget::ID_VALUE,
									LAYOUT_FILL_X|LAYOUT_CENTER_X|FRAME_SUNKEN|FRAME_THICK|LAYOUT_LEFT)

FXHorizontalSeparator.new(self, SEPARATOR_GROOVE|LAYOUT_FILL_X,20,20,20,20,0,0,30,30)				


#"Regel"-Button zum Erstellen der Regeln	
	rulesButton = FXButton.new(self, "Regeln erstellen", nil, nil, 0,LAYOUT_CENTER_X|
														FRAME_THICK|FRAME_RAISED|LAYOUT_TOP|LAYOUT_LEFT,
														0, 0, 0, 0, 20, 20, 5, 5)	
	
	rulesButton.connect(SEL_COMMAND) do	
			nonTermTemp = @nonTermTarget.to_s.delete" "
			@nonTermArray = nonTermTemp.split(',')
			
			termTemp = @termTarget.to_s.delete" "
			@termArray = termTemp.split(',')
			
			@startSymb = @startTarget.to_s
			
			ruleWindow = RuleWindow.new(self,@nonTermArray,@termArray,@startSymb)
			ruleWindow.execute
	end
 end
 
	def leadGrammar(ruleComplete,grammar)
		owner.drawGrammar(ruleComplete,grammar)
	end
	
end


#################################################################################################
###############################################################################################

# Klasse EditorWindow ist die Hauptanwendung zum Erstellen, durcken,
# speichern, laden und modifizieren von Grammatiken.
# Autor: Carolin Bongartz, Robert Meier, Danilo Ebert
class EditorWindow < FXMainWindow

# ffnet einen neue Anwendung des ScribbleFensters
  def initialize(app)
    # Call base class initializer first
    super(app, "Grammatik Editor", nil, nil, DECOR_ALL,
      0, 0, 700, 700)
		
		@currentGrammar = String.new()
	

    # Construct a horizontal frame to hold the main window's contents
    @contents = FXHorizontalFrame.new(self,
      LAYOUT_SIDE_TOP|LAYOUT_FILL_X|LAYOUT_FILL_Y, 0, 0, 0, 0, 0, 0, 0, 0)
	
		# Left pane contains the canvas
    @canvasFrame = FXVerticalFrame.new(@contents,
      FRAME_SUNKEN|LAYOUT_FILL_X|LAYOUT_FILL_Y|LAYOUT_TOP|LAYOUT_LEFT,
      0, 0, 0, 0, 10, 10, 10, 10)

  	
		# Place a label above the canvas
    FXLabel.new(@canvasFrame, "Grammatik:   SIC-Notation", nil,
      JUSTIFY_CENTER_X|LAYOUT_FILL_X)

    # Horizontal divider line
    FXHorizontalSeparator.new(@canvasFrame, SEPARATOR_GROOVE|LAYOUT_FILL_X)

    @grammarLabel = FXLabel.new(@canvasFrame, "",nil,JUSTIFY_LEFT|JUSTIFY_TOP|
									LAYOUT_LEFT|LAYOUT_CENTER_X|FRAME_SUNKEN|FRAME_THICK|
									LAYOUT_LEFT|LAYOUT_FILL_X|LAYOUT_FILL_Y)
   
    # Right pane for the buttons
    @buttonFrame = FXVerticalFrame.new(@contents,
      FRAME_SUNKEN|LAYOUT_FILL_Y|LAYOUT_TOP|LAYOUT_LEFT,
      0, 0, 0, 0, 10, 10, 10, 10)

  
		
		# Label above the buttons
    FXLabel.new(@buttonFrame, "Button Frame", nil,
      JUSTIFY_CENTER_X|LAYOUT_FILL_X)

    # Horizontal divider line
    FXHorizontalSeparator.new(@buttonFrame,
      SEPARATOR_RIDGE|LAYOUT_FILL_X)




	
# DialogBoxButton	zum Erzeugen des Dialogfensters
			dialButton = FXButton.new(@buttonFrame, "Grammatik erstellen", nil, nil, 0,
																FRAME_THICK|FRAME_RAISED|LAYOUT_FILL_X|LAYOUT_TOP|LAYOUT_LEFT,
																0, 0, 0, 0, 10, 10, 5, 5)	

			dialButton.connect(SEL_COMMAND)do
								dialog=DialogWindow.new(self)
								dialog.execute
								end


	
#Save-Button zum Speichern eines gezeichneten Bildes	
			saveButton = FXButton.new(@buttonFrame, "Grammatik speichern", nil, nil, 0,
																FRAME_THICK|FRAME_RAISED|LAYOUT_FILL_X|LAYOUT_TOP|LAYOUT_LEFT,
																0, 0, 0, 0, 10, 10, 5, 5)
			
		

#Load-Button zum Laden eines gespeicherten Bildes	
			loadButton = FXButton.new(@buttonFrame, "Grammatik laden", nil, nil, 0,
																FRAME_THICK|FRAME_RAISED|LAYOUT_FILL_X|LAYOUT_TOP|LAYOUT_LEFT,
																0, 0, 0, 0, 10, 10, 5, 5)
		




		

	

# Exit button
			FXButton.new(@buttonFrame, "&Exit", nil, app, FXApp::ID_QUIT,
									 FRAME_THICK|FRAME_RAISED|LAYOUT_FILL_X|LAYOUT_TOP|LAYOUT_LEFT,
									 0, 0, 0, 0, 10, 10, 5, 5)
									 

  end


	def drawGrammar(grammarString,grammar)
		@currentGrammar = grammar
		@grammarLabel.text = @currentGrammar.to_SIC
		puts grammarString
	end



  # Create and show the main window
  def create
    super                  # Create the windows
    show(PLACEMENT_SCREEN) # Make the main window appear
  end


end




if __FILE__ == $0
  # Construct the application object
  application = FXApp.new('Grammar', 'Editor')
  
  # Construct the main window
  editor = EditorWindow.new(application)
  
  # Create the application
  application.create
  
  # Run the application
  application.run
end
