	@@auf=/[(]/
	@@zu =/[)]/
	@@gauf=/\{/
	@@gzu=/\}/
	@@eauf=/\[/
	@@ezu=/\]/
	@@senkr=/[|]/
	@@minus=/[-]/
	@@gaense=/["]/
	@@stern=/\*/
	@@zuweis=/:=/
	@@nl=/\n/
	@@zahl=/[1-9]\d*/
	@@pattern=/Patterns:/
	@@token=/Tokens:/
	@@var=/\$\S/
	@@name=/\S{2,}/
	@@zeichen=/\S/
	

	
	@@tokenArray=[@@auf,@@zu,@@gauf,@@gzu,@@eauf,@@ezu,@@senkr,@@minus,@@gaense,@@stern,@@zuweis,@@nl,@@zahl,@@pattern,@@token,@@var,@@name,@@zeichen]
	
# ==zerlege(input)
# Diese Methode zerlegt einen Eingabestring in seine Bestandteile,
# die durch Ruby-Patterns gegeben sind
# Allerdings werden die einzelnen Teile nicht den Tokenklassen zugeordnet,
# sondern nur in ein Array geschrieben, welches von der Methode dann
# zurckgegeben wird. 

def zerlege(input)
  ergarray=Array.new(0)
	
	# Zusammenstellen des regulren Ausdrucks aus dem Token-Array
	tempStr="\\A("
	@@tokenArray.each do |regex|
		tempStr=tempStr+regex.source+"|"
	end
	tempStr=tempStr.chomp("|")
	tempStr=tempStr+("\)")
	tempRegexp=Regexp.new(tempStr)

  while (input.size > 0) do
    tokentemp=""
    c=(input.match(tempRegexp))
    if (c[0]!=nil and input.index(c[0])==0)
    tokentemp=c[0]
    end
    if(tokentemp=="")
			return Array.new
    end
    ergarray << tokentemp
    input=input.sub(tokentemp, '')
		input=input.sub(/[ ]*/, '')
  end   
  return ergarray
end

def bestimmeToken(text)
  return "auf "   if @@auf.match(text).to_s == text
  return "zu " 		if @@zu.match(text).to_s == text
  return "gauf "  if @@gauf.match(text).to_s == text
  return "gzu "  	if @@gzu.match(text).to_s == text
	return "eauf "  if @@eauf.match(text).to_s == text
	return "ezu "  	if @@ezu.match(text).to_s == text
	return "senkr " if @@senkr.match(text).to_s == text
	return "minus "	if @@minus.match(text).to_s == text
	return "gaense "if @@gaense.match(text).to_s == text
	return "stern " if @@stern.match(text).to_s == text
	return "nl "		if @@nl.match(text).to_s == text
	return "zuweis "if @@zuweis.match(text).to_s == text
	return "zahl " 	if @@zahl.match(text).to_s == text
	return "pattern "if @@pattern.match(text).to_s == text 
	return "token " if @@token.match(text).to_s == text
	return "var " 	if @@var.match(text).to_s == text
	return "name "  if @@name.match(text).to_s == text
	return "zeichen " if @@zeichen.match(text).to_s == text
	
end

def bestimme(input)
  zerlege(input).each do |part|
    print(bestimmeToken(part))
		if part=="\n"
			print("<<RETURN>>\n")
		else
			print("<<",part,">>\n")
		end
    
  end
end

example="
Patterns:
<addOpPattern> := ($+ | $-)
<multOpPattern> := ($* | $/)
<openingBracketPattern> := $(
<closingBracketPattern> := $)
<letterPattern> := ({$a-$z}|{$A-$Z})
<digitPattern> := {$0-$9}
<namePattern> := <letterPattern> (<letterPattern> | <digitPattern>)[0-*]
<numberPattern> := <digitPattern>[1-*]

Tokens:
<addOp> := <addOpPattern>
<multOp> := <multOpPattern>
<openingBracket> := <openingBracketPattern>
<closingBracket> := <closingBracketPattern>
<name> := <namePattern>
<number> := <numberPattern>"

erg = zerlege(example)

if erg.empty?
  print "Irregulaere Eingabe"
	
else
  print("+------------------------------------------------+\n")
  print("| Zerlegung ohne Zuordnung zu den Token-Klassen: |\n")
  print("+------------------------------------------------+\n\n")
  erg.each do |comp|
			if comp=="\n"
				print("<<RETURN>>  ")
			else
				print("<<",comp,">>  ")
			end
  end
  print("\n\n")
  print("+-----------------------------------------------+\n")
  print("| Zerlegung mit Zuordnung zu den Token-Klassen: |\n")
  print("+-----------------------------------------------+\n\n")
  print("Akkumulierte Tokens: \n--------------------\n\n")
  bestimme(example)

end 

